From bb6898536c42c9255fbcc4efdc6caf36d4349203 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 28 2020 01:12:42 +0000
Subject: [PATCH 1601/2232] Merge pull request #519 from dtolnay/operator-ne


Implement operator!= using a distinct symbol from operator==
---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 54c0bba..81eeef0 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -360,6 +360,15 @@ fn write_struct_operator_decls<'a>(out: &mut OutFile<'a>, strct: &'a Struct) {
             "bool {}(const {1} &, const {1} &) noexcept;",
             link_name, strct.name.cxx,
         );
+
+        if !derive::contains(&strct.derives, Trait::Eq) {
+            let link_name = mangle::operator(&strct.name, "__operator_ne");
+            writeln!(
+                out,
+                "bool {}(const {1} &, const {1} &) noexcept;",
+                link_name, strct.name.cxx,
+            );
+        }
     }
 
     out.end_block(Block::ExternC);
@@ -373,22 +382,28 @@ fn write_struct_operators<'a>(out: &mut OutFile<'a>, strct: &'a Struct) {
     out.set_namespace(&strct.name.namespace);
 
     if derive::contains(&strct.derives, Trait::PartialEq) {
-        let link_name = mangle::operator(&strct.name, "__operator_eq");
         out.next_section();
         writeln!(
             out,
             "bool {0}::operator==(const {0} &rhs) const noexcept {{",
             strct.name.cxx,
         );
+        let link_name = mangle::operator(&strct.name, "__operator_eq");
         writeln!(out, "  return {}(*this, rhs);", link_name);
         writeln!(out, "}}");
+
         out.next_section();
         writeln!(
             out,
             "bool {0}::operator!=(const {0} &rhs) const noexcept {{",
             strct.name.cxx,
         );
-        writeln!(out, "  return !(*this == rhs);");
+        if derive::contains(&strct.derives, Trait::Eq) {
+            writeln!(out, "  return !(*this == rhs);");
+        } else {
+            let link_name = mangle::operator(&strct.name, "__operator_ne");
+            writeln!(out, "  return {}(*this, rhs);", link_name);
+        }
         writeln!(out, "}}");
     }
 }
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 4bd955a..5020a39 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -164,17 +164,29 @@ fn expand_struct_operators(strct: &Struct) -> TokenStream {
     for derive in &strct.derives {
         let span = derive.span;
         match derive.what {
-            Trait::PartialEq => operators.extend({
+            Trait::PartialEq => {
                 let link_name = mangle::operator(&strct.name, "__operator_eq");
                 let local_name = format_ident!("__operator_eq_{}", strct.name.rust);
-                quote_spanned! {span=>
+                operators.extend(quote_spanned! {span=>
                     #[doc(hidden)]
                     #[export_name = #link_name]
                     extern "C" fn #local_name(lhs: &#ident, rhs: &#ident) -> bool {
                         *lhs == *rhs
                     }
+                });
+
+                if !derive::contains(&strct.derives, Trait::Eq) {
+                    let link_name = mangle::operator(&strct.name, "__operator_ne");
+                    let local_name = format_ident!("__operator_ne_{}", strct.name.rust);
+                    operators.extend(quote_spanned! {span=>
+                        #[doc(hidden)]
+                        #[export_name = #link_name]
+                        extern "C" fn #local_name(lhs: &#ident, rhs: &#ident) -> bool {
+                            *lhs != *rhs
+                        }
+                    });
                 }
-            }),
+            }
             _ => {}
         }
     }
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 0ad753d..021b0c3 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -20,6 +20,7 @@ pub mod ffi {
         z: usize,
     }
 
+    #[derive(PartialEq)]
     struct SharedString {
         msg: String,
     }

